% draw7SegNumbers() - Developed for an EEGLAB plugin pop_sevenSegmentica().
%                     See pop_sevenSegmentica help.
% Reference:
%    digital_clock_v2.m is written by Jeremy Chen. https://www.mathworks.com/matlabcentral/fileexchange/26488-simple-digital-clock?s_tid=FX_rc2_behav

% History:
% 06/14/2019 Makoto. Created.

% Copyright (C) 2019, Makoto Miyakoshi. SCCN, INC, UCSD.
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1.07  USA

function draw7SegNumbers(ax, intInput, intensity)

% Higher the intensity, closer to black.
intensity = 1-intensity;

% Set up patch geometry.
disp.topcenter = [0 5 4 1 0;0 0 -1 -1 0];
disp.topright  = [5 5 4 4 5;-0.5 -5.5 -4.5 -1.5 -0.5];
disp.botright  = [5 5 4 4 5;-6.5 -11.5 -10.5 -7.5 -6.5];
disp.botcenter = [0 1 4 5 0;-12 -11 -11 -12 -12];
disp.botleft   = [0 1 1 0 0;-6.5 -7.5 -10.5 -11.5 -6.5];
disp.topleft   = [0 1 1 0 0;-0.5 -1.5 -4.5 -5.5 -0.5];
disp.midcenter = [0 0.5 4.5 5 4.5 0.5 0;-6 -5.5 -5.5 -6 -6.5 -6.5 -6];

switch intInput
    case 0
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [1 1 1], 'LineStyle', 'none');
        
    case 1
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [1 1 1], 'LineStyle', 'none');
        
    case 2
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        
    case 3
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        
    case 4
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        
    case 5
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        
    case 6
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        
    case 7
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [1 1 1], 'LineStyle', 'none');
        
    case 8
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        
    case 9
        patch(ax, disp.topcenter(1,:), disp.topcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.topright( 1,:), disp.topright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botright( 1,:), disp.botright( 2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botcenter(1,:), disp.botcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.botleft(  1,:), disp.botleft(  2,:), [1 1 1], 'LineStyle', 'none');
        patch(ax, disp.topleft(  1,:), disp.topleft(  2,:), [intensity intensity intensity], 'LineStyle', 'none');
        patch(ax, disp.midcenter(1,:), disp.midcenter(2,:), [intensity intensity intensity], 'LineStyle', 'none');
end

% Crop the number.
xlim(ax, [0 5])
ylim(ax, [-12 0])

% Clear axis
set(get(ax, 'XAxis'), 'visible', 'off')
set(get(ax, 'YAxis'), 'visible', 'off')